=== tests/run-make/c-link-to-rust-va-list-fn/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) checkrust.rs
	$(CC) test.c $(call STATICLIB,checkrust) $(call OUT_EXE,test) $(EXTRACFLAGS)
	$(call RUN,test)
