=== debian/changelog ===
rustc-1.76 (1.76.0+dfsg0ubuntu1-0ubuntu0.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2052985)

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 25 Jun 2024 10:06:58 -0600
